searchNodes=[{"ref":"TelemetryMetricsRiemann.html","title":"TelemetryMetricsRiemann","type":"module","doc":"Telemetry.Metrics reporter for riemann-compatible metric servers. To use it, start the reporter with the start_link/1 function, providing it a list of Telemetry.Metrics metric definitions: import Telemetry.Metrics TelemetryMetricsRiemann.start_link( metrics: [ counter(&quot;http.request.count&quot;), sum(&quot;http.request.payload_size&quot;), last_value(&quot;vm.memory.total&quot;) ] ) Note that in the real project the reporter should be started under a supervisor, e.g. the main supervisor of your application. By default the reporter formats and delegates the metrics to a riemann client which will send the metrics to a configured riemann server. Note that the reporter doesn&#39;t aggregate metrics in-process - it sends metric updates to riemann whenever a relevant Telemetry event is emitted. Translation between Telemetry.Metrics and riemann In this section we walk through how the Telemetry.Metrics metric definitions are mapped to riemann metrics and their types at runtime. Telemetry.Metrics names are translated as follows: if the event name was provided as a string, e.g. &quot;http.request.count&quot;, it is sent to riemann server as-is (using the service field) if the event name was provided as a list of atoms, e.g. [:http, :request, :count], it is first converted to a string by joiging the segments with dots. In this example, the riemann service name would be &quot;http.request.count&quot; as well If the metric has tags, it is send to to riemann as tags. If the metric has tag value, it is converted to riemann attributes fields. Also, the following attributes, if present will be used to fill the riemann default fields protocol and consequently removed from attributes: host, a hostname state, any string which represents a state &quot;ok&quot;, &quot;critical&quot;, &quot;online&quot; ttl, a floating-point-time, in seconds, that this event is considered valid for time, the time of the event, in unix epoch time time_micros, the time of the event, in microseconds All metrics values from Telemetry.Metrics type is converted to riemann metric field. There is no special conversion rules. The riemann server, based on the configurations done, has an important role to convert/calculate each metric send by TelemetryMetricsRiemann. This reporter acts only as bridge to the riemann protocol. The following table shows how Telemetry.Metrics metrics map riemann metrics: Telemetry.Metricsriemann last_valuemetric field, always set to an absolute value countermetric field, always increased by 1 summetric field, increased and decreased by the provided value summarymetric field recording individual measurement histogrammetric field recording individual measurement Counter Telemetry.Metrics counter is simply represented as a riemann metric. Each event the metric is based on increments the counter by 1. Example, given the metric definition: counter(&quot;http.request.count&quot;) and the event :telemetry.execute([:http, :request], %{duration: 120}) the following riemann event would be sent to riemann server [service: &quot;http.requests.count&quot;, metric: 1] Last value Last value metric is represented as a riemann metric value, whose values are always set to the value of the measurement from the most recent event. Example, given the metric definition: last_value(&quot;vm.memory.total&quot;) and the event :telemetry.execute([:vm, :memory], %{total: 1024}) the following riemann event would be sent to riemann server [service: &quot;vm.memory.total&quot;, metric: 1024] Sum Sum metric is also represented as a riemann metric value - the difference is that it always changes relatively and is never set to an absolute value. Example, given the metric definition: sum(&quot;http.request.payload_size&quot;) and the event :telemetry.execute([:http, :request], %{payload_size: 1076}) the following riemann event would be sent to riemann server [service: &quot;http.request.payload_size&quot;, metric: +1024] When the measurement is negative, the riemann metric is decreased accordingly. Summary Summary metric is also represented as a riemann metric value - the difference is that it always changes relatively and is never set to an absolute value. Example, given the metric definition: summary(&quot;http.request.duration&quot;) and the event :telemetry.execute([:http, :request], %{duration: 120}) the following riemann event would be sent to riemann server [service: &quot;http.request.duration&quot;, metric: 120] Distribution There is no distribution metric type in riemann equivalent to Telemetry.Metrics distribution. However, a distribution metric is also represented as a riemann metric value. Example, given the metric definition: distribution(&quot;http.request.duration&quot;, buckets: [0]) and the event :telemetry.execute([:http, :request], %{duration: 120}) the following riemann event would be sent to riemann server [service: &quot;http.request.duration&quot;, metric: 120] Since histograms are configured on the riemann server side (for example using riemann folds), the :buckets option has no effect when used with this reporter. Prefixing metric names Sometimes it&#39;s convenient to prefix all metric names with particular value, to group them by the name of the service, the host, or something else. You can use :prefix option to provide a prefix which will be prepended to all metrics published by the reporter."},{"ref":"TelemetryMetricsRiemann.html#child_spec/1","title":"TelemetryMetricsRiemann.child_spec/1","type":"function","doc":"Reporter&#39;s child spec. This function allows you to start the reporter under a supervisor like this: children = [ {TelemetryMetricsRiemann, options} ] See start_link/1 for a list of available options."},{"ref":"TelemetryMetricsRiemann.html#start_link/1","title":"TelemetryMetricsRiemann.start_link/1","type":"function","doc":"Starts a reporter and links it to the calling process. The available options are: :metrics - a list of Telemetry.Metrics metric definitions which will be published by the reporter :client - the module that implements riemann client interface: TelemetryMetricsRiemann.Riemannx or TelemetryMetricsRiemann.Katja :prefix - a prefix prepended to the name of each metric published by the reporter. Defaults to nil. You can read more about all the options in the TelemetryMetricsRiemann module documentation. Example import Telemetry.Metrics TelemetryMetricsRiemann.start_link( metrics: [ counter(&quot;http.request.count&quot;), sum(&quot;http.request.payload_size&quot;), last_value(&quot;vm.memory.total&quot;) ], prefix: &quot;my-service&quot;, client: TelemetryMetricsRiemann.Riemannx )"},{"ref":"TelemetryMetricsRiemann.html#t:option/0","title":"TelemetryMetricsRiemann.option/0","type":"type","doc":""},{"ref":"TelemetryMetricsRiemann.html#t:options/0","title":"TelemetryMetricsRiemann.options/0","type":"type","doc":""},{"ref":"TelemetryMetricsRiemann.Client.Katja.html","title":"TelemetryMetricsRiemann.Client.Katja","type":"module","doc":"This module implements an adapter to Katja riemann client."},{"ref":"TelemetryMetricsRiemann.Client.Riemannx.html","title":"TelemetryMetricsRiemann.Client.Riemannx","type":"module","doc":"This module implements an adapter to riemannx riemann client."}]